# -*- coding: utf-8 -*-

import sys

from cine_encoder import ui_main
from cine_encoder import ui_taskcomplete
from cine_encoder import ui_donate
from cine_encoder import ui_about
from cine_encoder import ui_settings
from cine_encoder import ui_smartsettings
from cine_encoder import files_rc

import os
import math
import multiprocessing
import time
import webbrowser
from PyQt5 import QtWidgets
from PyQt5.QtCore import QProcess
from PyQt5.QtGui import QPixmap
from pymediainfo import MediaInfo


# -------------------------------------------- Main program ----------------------------------------------------------

class ExampleApp(QtWidgets.QMainWindow, ui_main.Ui_MainWindow):
    def __init__(self, parent=None):
        super().__init__(parent)
        self.procedure_1 = QProcess()
        self.procedure_1.setProcessChannelMode(QProcess.MergedChannels)
        self.procedure_1.readyRead.connect(self.progress_1)
        self.procedure_2 = QProcess()
        self.procedure_2.setProcessChannelMode(QProcess.MergedChannels)
        self.procedure_2.readyRead.connect(self.progress_2)
        self.procedure_3 = QProcess()
        self.procedure_3.setProcessChannelMode(QProcess.MergedChannels)
        self.procedure_3.readyRead.connect(self.progress_3)
        self.procedure_4 = QProcess()
        self.procedure_4.setProcessChannelMode(QProcess.MergedChannels)
        self.procedure_4.readyRead.connect(self.progress_4)
        self.procedure_5 = QProcess()
        self.setupUi(self)

# ------------------------------------------- Main Menu Buttons ------------------------------------------------------

        self.actionAbout.clicked.connect(self.about)
        self.actionDonate.clicked.connect(self.donate)
        self.actionSettings.clicked.connect(self.settings)
        self.turnLeftStack_1.clicked.connect(lambda: self.stackedWidget_1.setCurrentIndex(0))
        self.turnRightStack_1.clicked.connect(lambda: self.stackedWidget_1.setCurrentIndex(1))
        self.turnLeftStack_2.clicked.connect(self.turnStackLeft)
        self.turnRightStack_2.clicked.connect(self.turnStackRight)

# ---------------------------------------- Status and Buttons ---------------------------------------------------------

        #self.label_53.hide()  # (need add to ui_main)
        #self.label_54.hide()  # (need add to ui_main)
        #self.label_55.hide()  # (need add to ui_main)
        #self.progressBar.hide()  # (need add to ui_main)
        #from cine_encoder import files_rc
        self.pushButton_1.clicked.connect(self.open_file)
        self.pushButton_2.clicked.connect(self.save_file)
        self.pushButton_3.clicked.connect(self.smart_detect)
        self.pushButton_4.clicked.connect(self.stop)
        self.comboBox_1.currentTextChanged.connect(self.settings_menu)
        self.comboBox_2.currentTextChanged.connect(self.change_prefix)
        self.comboBox_4.currentTextChanged.connect(self.settings_menu_mode)
        self.comboBox_12.currentTextChanged.connect(self.settings_menu_audio)
        self.comboBox_15.currentTextChanged.connect(self.settings_hdr)

    def turnStackLeft(self):
        a = self.stackedWidget_2.currentIndex()
        if a != 0:
            self.stackedWidget_2.setCurrentIndex(a-1)
        else:
            self.stackedWidget_2.setCurrentIndex(0)

    def turnStackRight(self):
        a = self.stackedWidget_2.currentIndex()
        if a != 3:
            self.stackedWidget_2.setCurrentIndex(a+1)
        else:
            self.stackedWidget_2.setCurrentIndex(3)

# ----------------------------------------------- Dialogs -------------------------------------------------------------

    def open_file(self):
        global message
        global fmt, width, height, fps, dur
        global hdr1, hdr2, hdr3, hdr4, hdr5, hdr6, hdr7, hdr8, hdr9, hdr10, hdr11
        self.lineEdit_1.clear()
        #self.lineEdit_2.clear()
        self.lineEdit_3.clear()
        self.lineEdit_4.clear()
        self.lineEdit_5.clear()
        self.lineEdit_6.clear()
        self.lineEdit_7.clear()
        self.lineEdit_8.clear()
        self.comboBox_9.clear()
        self.comboBox_10.clear()
        self.comboBox_11.clear()
        self.comboBox_15.clear()
        self.comboBox_16.clear()
        self.label_format.setText("n/a")
        self.label_duration.setText("n/a")
        self.label_resolution.setText("n/a")
        self.label_subsampling.setText("n/a")
        self.label_bitrate.setText("n/a")
        self.label_fps.setText("n/a")
        self.label_aspect_ratio.setText("n/a")
        self.label_color_space.setText("n/a")
        self.label_bit_depth.setText("n/a")
        self.label_audio_1.clear()
        self.label_audio_2.clear()
        self.label_audio_3.clear()
        self.label_audio_4.clear()
        self.label_audio_5.clear()
        self.label_audio_6.clear()
        self.label_audio_7.clear()
        self.label_audio_8.clear()
        self.label_audio_9.clear()
        self.label_53.hide()
        self.label_54.hide()
        self.label_55.hide()
        self.progressBar.hide()
        try:
            file_name_open = QtWidgets.QFileDialog.getOpenFileName(self, "Open File", "Untitled", ("Video Files: *.avi, "
                                                                                                   "*m2ts, *.m4v, *.mkv, "
                                                                                                   "*.mov, *.mp4, *.mpeg, "
                                                                                                   "*.mpg, *.mxf, *.ts, "
                                                                                                   "*.webm (*.avi *.m2ts "
                                                                                                   "*.m4v *.mkv *.mov "
                                                                                                   "*.mp4 *.mpeg *.mpg "
                                                                                                   "*.mxf *.ts *.webm)"))
            file_name = file_name_open[0]
            self.lineEdit_1.setText(file_name)
        except:
            message = "The file cannot be opened."
            self.task_complete()
        else:
            try:
                media_info = MediaInfo.parse(self.lineEdit_1.text())
                fmt = str(media_info.tracks[1].format)
                dur = 0.001*round(float(media_info.tracks[0].duration))
                h = math.trunc(dur / 3600)
                m = math.trunc((dur - (h * 3600)) / 60)
                s = math.trunc(dur - (h * 3600) - (m * 60))
                chroma_subsampling = str(media_info.tracks[1].chroma_subsampling)
                bit_rate = str(round(media_info.tracks[0].overall_bit_rate/1000000, 1))
                aspect_ratio = str(media_info.tracks[1].display_aspect_ratio)
                color_space = str(media_info.tracks[1].color_space)
                bit_depth = str(media_info.tracks[1].bit_depth)
                width = str(media_info.tracks[1].width)
                height = str(media_info.tracks[1].height)
                fps = str(media_info.tracks[1].frame_rate)
                color_range = str(media_info.tracks[1].color_range)
                color_primaries = str(media_info.tracks[1].color_primaries)
                matrix_coefficients = str(media_info.tracks[1].matrix_coefficients)
                transfer_characteristics = str(media_info.tracks[1].transfer_characteristics)
                mastering_display_luminance = str(media_info.tracks[1].mastering_display_luminance).replace('min: ', '').replace('max: ', '').replace(' cd/m2', '')
                min_luminance = mastering_display_luminance.split(', ')[0]
                max_luminance = mastering_display_luminance.replace(min_luminance, '').replace(', ', '')
                maxCll = str(media_info.tracks[1].maximum_content_light_level)
                maxFall = str(media_info.tracks[1].maximum_frameaverage_light_level)
                mastering_display_color_primaries = str(media_info.tracks[1].mastering_display_color_primaries)
                i = 0
                a = []
                b = []
                for track in media_info.tracks:
                    if track.track_type == 'Audio' and i < 9:
                        i = i + 1
                        a.append(track.format)
                        b.append(round(track.sampling_rate/1000))
                        if i == 1:
                            self.label_audio_1.setText(a[0] + "  " + str(b[0]) + " KHz")
                        if i == 2:
                            self.label_audio_2.setText(a[1] + "  " + str(b[1]) + " KHz")
                        if i == 3:
                            self.label_audio_3.setText(a[2] + "  " + str(b[2]) + " KHz")
                        if i == 4:
                            self.label_audio_4.setText(a[3] + "  " + str(b[3]) + " KHz")
                        if i == 5:
                            self.label_audio_5.setText(a[4] + "  " + str(b[4]) + " KHz")
                        if i == 6:
                            self.label_audio_6.setText(a[5] + "  " + str(b[5]) + " KHz")
                        if i == 7:
                            self.label_audio_7.setText(a[6] + "  " + str(b[6]) + " KHz")
                        if i == 8:
                            self.label_audio_8.setText(a[7] + "  " + str(b[7]) + " KHz")
                        if i == 9:
                            self.label_audio_9.setText(a[8] + "  " + str(b[8]) + " KHz")
                self.comboBox_9.addItems([color_primaries.replace('.', '')])
                self.comboBox_10.addItems([matrix_coefficients.replace(' ', '').replace('.', '').replace('on-', '').replace('onstant', '')])
                self.comboBox_11.addItems([transfer_characteristics.replace('.', '')])
                if len(mastering_display_color_primaries) > 10:
                    mdcp = mastering_display_color_primaries.split(',')
                    r = mdcp[0].replace('R: ', '').replace('x=', '').replace(' ', ',').replace('y=', '').replace('000', '0').replace('00', '0')
                    g = mdcp[1].replace(' G: ', '').replace('x=', '').replace(' ', ',').replace('y=', '').replace('000', '0').replace('00', '0')
                    b = mdcp[2].replace(' B: ', '').replace('x=', '').replace(' ', ',').replace('y=', '').replace('000', '0').replace('00', '0')
                    w = mdcp[3].replace(' White point: ', '').replace('x=', '').replace(' ', ',').replace('y=', '').replace('000', '0').replace('00', '0')
                    chr_coord = r + "," + g + "," + b
                    white_coord = w
                    hdr10 = chr_coord
                    hdr11 = white_coord
                    self.comboBox_15.addItems(["Undefined", "Display P3", "DCI P3", "BT.2020", "BT.709"])
                else:
                    self.comboBox_15.addItems([mastering_display_color_primaries, "Display P3", "DCI P3", "BT.2020", "BT.709"])
                self.comboBox_16.addItems([color_range, "Limited", "Full"])
                self.lineEdit_3.setText(maxCll.replace(' cd/m2', ''))
                self.lineEdit_4.setText(maxFall.replace(' cd/m2', ''))
                self.lineEdit_5.setText(max_luminance)
                self.lineEdit_6.setText(min_luminance)
                self.label_format.setText(fmt)
                self.label_resolution.setText(width + "x" + height)
                self.label_duration.setText(str(h) + "h " + str(m) + "m " + str(s) + "s")
                self.label_fps.setText(fps)
                self.label_subsampling.setText(chroma_subsampling)
                self.label_bitrate.setText(bit_rate + " Mbps")
                self.label_aspect_ratio.setText(aspect_ratio)
                self.label_color_space.setText(color_space)
                self.label_bit_depth.setText(bit_depth + " bit")
            except:
                pass
            else:
                hdr1 = self.comboBox_16.currentText()
                hdr2 = self.comboBox_9.currentText()
                hdr3 = self.comboBox_10.currentText()
                hdr4 = self.comboBox_11.currentText()
                hdr5 = self.lineEdit_5.text()
                hdr6 = self.lineEdit_6.text()
                hdr7 = self.lineEdit_3.text()
                hdr8 = self.lineEdit_4.text()
                hdr9 = self.comboBox_15.currentText()
                try:
                    cmd = f'ffmpeg -hide_banner -ss 5 -i "{file_name}" -vframes 1 -q:v 5 -y "./ce_thumbnail.jpg"'
                    self.procedure_5.start(cmd)
                    self.procedure_5.waitForFinished()
                    pixmap = QPixmap('./ce_thumbnail.jpg')
                    self.labelThumb.setPixmap(pixmap)
                except:
                    pass

    def save_file(self):
        self.lineEdit_2.clear()
        prefix = self.comboBox_2.currentText()
        file_name_save = QtWidgets.QFileDialog.getSaveFileName(self, "Save As", "Untitled." + prefix.lower(), "All Files (*.*)")
        self.lineEdit_2.setText(file_name_save[0])

    def change_prefix(self):
        prefix = self.comboBox_2.currentText()
        if self.lineEdit_2.text() != "":
            file_name_save = self.lineEdit_2.text()
            pos_ext = file_name_save.rfind('.')
            len_str = len(file_name_save)
            if pos_ext == -1:
                self.lineEdit_2.setText(file_name_save + "." + prefix.lower())
            else:
                if (len_str - pos_ext) < 6:
                    self.lineEdit_2.setText(file_name_save[:pos_ext+1] + prefix.lower())
                else:
                    self.lineEdit_2.setText(file_name_save + "." + prefix.lower())

    def task_complete(self):
        self.task_complete_app = TaskCompleteApp()
        self.task_complete_app.show()
        self.task_complete_app.textBrowser.clear()
        self.task_complete_app.textBrowser.append(message)
        self.task_complete_app.pushButton_4.clicked.connect(self.task_complete_app.close)

    def about(self):
        self.aboutapp = AboutApp()
        self.aboutapp.show()
        self.aboutapp.toolButton_6.clicked.connect(self.aboutapp.close)
        self.aboutapp.label_11.setText('<a href="https://github.com/CineEncoder/cine-encoder"> https://github.com/CineEncoder/cine-encoder </a>')
        self.aboutapp.label_11.setOpenExternalLinks(True)
        self.aboutapp.label_12.setText('<a href="https://github.com/CineEncoder/cine-encoder/blob/master/LICENSE"> License: GNU Lesser General Public License Version 3 </a>')
        self.aboutapp.label_12.setOpenExternalLinks(True)

    def donate(self):
        self.donateapp = DonateApp()
        self.donateapp.show()
        self.donateapp.toolButton_7.clicked.connect(lambda: webbrowser.open('https://paypal.me/KozhukharenkoOleg?locale.x=ru_RU'))
        self.donateapp.toolButton_8.clicked.connect(lambda: webbrowser.open('https://blockchain.com/btc/payment_request?address=14ukiWCK2f8vFNPP3qKbo2vfaSGRMN63qL&amount=0.00005448&message=Cine Encoder donation'))

    def settings(self):
        self.settings_app = SettingsApp()
        self.settings_app.show()
        self.settings_app.pushButton_5.clicked.connect(self.select_temp_folder)
        self.settings_app.pushButton_6.clicked.connect(self.save_settings)
        self.settings_app.pushButton_7.clicked.connect(self.settings_app.close)
        self.settings_app.pushButton_8.clicked.connect(self.reset_settings)
        global message
        try:
            f = open(r'./.ce_settings', 'r', encoding='utf-8')
        except:
            message = "Please select a temporary folder!\n"
            self.task_complete()
        else:
            i = 0
            a = []
            for line in f:
                i = i + 1
                a.append(line)
                if i == 1:
                    if a[0].find('temp_folder:') != -1 and a[0].find('[default]') != -1:
                        self.settings_app.lineEdit_9.clear()
                    if a[0].find('temp_folder:') != -1 and a[0].find('[default]') == -1:
                        b = a[0].split(':')
                        c = b[1].replace('[', '').replace(']\n', '')
                        self.settings_app.lineEdit_9.setText(c)
            f.close()
            if i == 0:
                message = "Settings file error!\n"
                self.task_complete()

    def select_temp_folder(self):
        self.settings_app.lineEdit_9.clear()
        temp_folder_name = QtWidgets.QFileDialog.getExistingDirectory(self.settings_app, 'Select temp folder', '/home')
        self.settings_app.lineEdit_9.setText(temp_folder_name)

    def save_settings(self):
        global message
        temp_folder_name = self.settings_app.lineEdit_9.text()
        try:
            f = open(r'./.ce_settings', 'w', encoding='utf-8')
        except:
            message = "Settings file not found!\n"
            self.task_complete()
        else:
            if temp_folder_name == "":
                f.write('temp_folder:[default]' + '\n')
            else:
                f.write('temp_folder:[' + temp_folder_name + ']\n')
            f.close()
            self.settings_app.close()

    def reset_settings(self):
        self.settings_app.lineEdit_9.clear()

    def smart_settings(self):
        global k1, smart_bitrate
        self.smart_settings_app = SmartSettingsApp()
        self.smart_settings_app.show()
        self.smart_settings_app.lineEdit_BPP.setText(str(k))
        k1 = k
        self.smart_settings_app.doubleSpinBox_BPP_2.setValue(k1)
        smart_bitrate = round((k1 * int(width) * int(height) * float(fps)) / (1024))
        self.smart_settings_app.doubleSpinBox_BR.setValue(smart_bitrate)
        self.smart_settings_app.doubleSpinBox_MR.setValue(round(1.1*smart_bitrate))
        self.smart_settings_app.lineEdit_5.setText(str(round((dur*smart_bitrate)/(8*1024))))
        print(fmt)

        self.smart_settings_app.horizontalSlider.valueChanged.connect(self.slider_changed)
        self.smart_settings_app.pushButton_10.clicked.connect(self.execute_make_preset)
        self.smart_settings_app.pushButton_11.clicked.connect(self.smart_settings_app.close)

    def slider_changed(self):
        global k1
        corr = self.smart_settings_app.horizontalSlider.value()/500
        self.smart_settings_app.doubleSpinBox_BPP_2.setValue(k1+corr)
        smart_bitrate = round(((k1+corr) * int(width) * int(height) * float(fps)) / (1024))
        self.smart_settings_app.doubleSpinBox_BR.setValue(smart_bitrate)
        self.smart_settings_app.doubleSpinBox_MR.setValue(round(1.1*smart_bitrate))
        self.smart_settings_app.lineEdit_5.setText(str(round((dur*smart_bitrate)/(8*1024))))

    def execute_make_preset(self):
        global smart_bitrate
        self.comboBox_5.clear()
        self.comboBox_6.clear()
        BR = round(self.smart_settings_app.doubleSpinBox_BR.value())
        MR = round(self.smart_settings_app.doubleSpinBox_MR.value())
        self.comboBox_5.addItems([str(BR)+"k", "Smart detect", "65M",
                                  "60M", "55M", "50M", "40M", "30M", "20M", "10M", "5M"])
        self.comboBox_6.addItems([str(MR)+"k", "Smart detect", "65M",
                                  "60M", "55M", "50M", "40M", "30M", "20M", "10M", "5M"])
        self.smart_settings_app.close()
        self.make_preset()

# ------------------------------------------------ Settings menu -------------------------------------------------------

    def settings_menu(self):
        self.comboBox_16.clear()
        self.comboBox_9.clear()
        self.comboBox_10.clear()
        self.comboBox_11.clear()
        self.lineEdit_5.clear()
        self.lineEdit_6.clear()
        self.lineEdit_3.clear()
        self.lineEdit_4.clear()
        self.comboBox_15.clear()
        self.comboBox_2.setEnabled(True)
        self.comboBox_3.setEnabled(True)
        self.comboBox_4.setEnabled(True)
        self.comboBox_12.setEnabled(True)
        self.comboBox_2.clear()
        self.comboBox_3.clear()
        self.comboBox_4.clear()
        self.comboBox_12.clear()
        try:
            if self.comboBox_1.currentText() == "H265  10 bit":
                self.comboBox_2.addItems(["MKV", "MOV", "MP4"])
                self.comboBox_3.addItems(["CPU", "NVENC"])
                self.comboBox_4.addItems(["VBR", "CQP"])
                self.comboBox_12.addItems(["AAC", "AC3", "DTS", "From source"])
                self.comboBox_16.addItems([hdr1, "Limited", "Full"])
                self.comboBox_9.addItems([hdr2])
                self.comboBox_10.addItems([hdr3])
                self.comboBox_11.addItems([hdr4])
                self.lineEdit_5.setText(hdr5)
                self.lineEdit_6.setText(hdr6)
                self.lineEdit_3.setText(hdr7)
                self.lineEdit_4.setText(hdr8)
                self.comboBox_15.addItems([hdr9, "Display P3", "DCI P3", "BT.2020", "BT.709"])

            if self.comboBox_1.currentText() == "H265  8 bit":
                self.comboBox_2.addItems(["MKV", "MOV", "MP4", "M2TS", "TS"])
                self.comboBox_3.addItems(["CPU", "NVENC"])
                self.comboBox_4.addItems(["VBR", "CQP"])
                self.comboBox_12.addItems(["AAC", "AC3", "DTS", "From source"])
                self.comboBox_16.addItems(["Unsprt"])
                self.comboBox_9.addItems(["Unsprt"])
                self.comboBox_10.addItems(["Unsprt"])
                self.comboBox_11.addItems(["Unsprt"])
                self.lineEdit_5.setText("Unsprt")
                self.lineEdit_6.setText("Unsprt")
                self.lineEdit_3.setText("Unsprt")
                self.lineEdit_4.setText("Unsprt")
                self.comboBox_15.addItems(["Unsprt"])

            if self.comboBox_1.currentText() == "H264  8 bit":
                self.comboBox_2.addItems(["MKV", "MOV", "MP4", "M2TS", "TS"])
                self.comboBox_3.addItems(["CPU", "NVENC"])
                self.comboBox_4.addItems(["VBR", "CQP"])
                self.comboBox_12.addItems(["AAC", "AC3", "DTS", "From source"])
                self.comboBox_16.addItems(["Unsprt"])
                self.comboBox_9.addItems(["Unsprt"])
                self.comboBox_10.addItems(["Unsprt"])
                self.comboBox_11.addItems(["Unsprt"])
                self.lineEdit_5.setText("Unsprt")
                self.lineEdit_6.setText("Unsprt")
                self.lineEdit_3.setText("Unsprt")
                self.lineEdit_4.setText("Unsprt")
                self.comboBox_15.addItems(["Unsprt"])

            if self.comboBox_1.currentText() == "VP9  10 bit":
                self.comboBox_2.addItems(["WebM", "MKV"])
                self.comboBox_3.addItems(["CPU"])
                self.comboBox_4.addItems(["ABR", "CRF"])
                self.comboBox_12.addItems(["Opus", "Vorbis", "From source"])
                self.comboBox_3.setEnabled(False)
                self.comboBox_16.addItems([hdr1, "Limited", "Full"])
                self.comboBox_9.addItems([hdr2])
                self.comboBox_10.addItems([hdr3])
                self.comboBox_11.addItems([hdr4])
                self.lineEdit_5.setText(hdr5)
                self.lineEdit_6.setText(hdr6)
                self.lineEdit_3.setText(hdr7)
                self.lineEdit_4.setText(hdr8)
                self.comboBox_15.addItems([hdr9, "Display P3", "DCI P3", "BT.2020", "BT.709"])

            if self.comboBox_1.currentText() == "AV1  10 bit":
                self.comboBox_2.addItems(["WebM", "MKV"])
                self.comboBox_3.addItems(["CPU"])
                self.comboBox_4.addItems(["ABR", "CRF"])
                self.comboBox_12.addItems(["Opus", "Vorbis", "From source"])
                self.comboBox_3.setEnabled(False)
                self.comboBox_16.addItems([hdr1, "Limited", "Full"])
                self.comboBox_9.addItems([hdr2])
                self.comboBox_10.addItems([hdr3])
                self.comboBox_11.addItems([hdr4])
                self.lineEdit_5.setText(hdr5)
                self.lineEdit_6.setText(hdr6)
                self.lineEdit_3.setText(hdr7)
                self.lineEdit_4.setText(hdr8)
                self.comboBox_15.addItems([hdr9, "Display P3", "DCI P3", "BT.2020", "BT.709"])

            if self.comboBox_1.currentText() == "ProRes HQ" or self.comboBox_1.currentText() == "ProRes 4444" or \
                    self.comboBox_1.currentText() == "DNxHR HQX":
                self.comboBox_2.addItems(["MOV"])
                self.comboBox_3.addItems(["CPU"])
                self.comboBox_4.addItems(["Auto"])
                self.comboBox_12.addItems(["PCM 16 bit", "PCM 24 bit", "PCM 32 bit"])
                self.comboBox_2.setEnabled(False)
                self.comboBox_3.setEnabled(False)
                self.comboBox_4.setEnabled(False)
                #self.comboBox_12.setEnabled(False)
                self.comboBox_16.addItems([hdr1, "Limited", "Full"])
                self.comboBox_9.addItems([hdr2])
                self.comboBox_10.addItems([hdr3])
                self.comboBox_11.addItems([hdr4])
                self.lineEdit_5.setText(hdr5)
                self.lineEdit_6.setText(hdr6)
                self.lineEdit_3.setText(hdr7)
                self.lineEdit_4.setText(hdr8)
                self.comboBox_15.addItems([hdr9, "Display P3", "DCI P3", "BT.2020", "BT.709"])

            if self.comboBox_1.currentText() == "From source":
                self.comboBox_2.addItems(["MKV", "MOV", "MP4", "M2TS", "TS"])
                self.comboBox_3.addItems(["CPU"])
                self.comboBox_4.addItems(["Auto"])
                self.comboBox_12.addItems(["AAC", "AC3", "DTS", "Vorbis", "Opus", "From source"])
                self.comboBox_3.setEnabled(False)
                self.comboBox_4.setEnabled(False)
                self.comboBox_16.addItems([hdr1, "Limited", "Full"])
                self.comboBox_9.addItems([hdr2])
                self.comboBox_10.addItems([hdr3])
                self.comboBox_11.addItems([hdr4])
                self.lineEdit_5.setText(hdr5)
                self.lineEdit_6.setText(hdr6)
                self.lineEdit_3.setText(hdr7)
                self.lineEdit_4.setText(hdr8)
                self.comboBox_15.addItems([hdr9, "Display P3", "DCI P3", "BT.2020", "BT.709"])
        except:
            pass

    def settings_menu_mode(self):
        self.comboBox_5.setEnabled(True)
        self.comboBox_6.setEnabled(True)
        self.comboBox_5.clear()
        self.comboBox_6.clear()
        if self.comboBox_4.currentText() == "Auto":
            self.label_credits_19.setText("Bitrate:")
            self.label_credits_20.show()
            self.comboBox_6.show()
            self.comboBox_5.addItems(["Auto"])
            self.comboBox_6.addItems(["Auto"])
            self.comboBox_5.setEnabled(False)
            self.comboBox_6.setEnabled(False)
        if self.comboBox_4.currentText() == "CQP":
            self.label_credits_19.setText("Quant:")
            self.label_credits_20.hide()
            self.comboBox_6.hide()
            self.comboBox_5.addItems(["51", "45", "40", "35", "30", "25", "24", "23", "22", "21", "20", "19", "18",
                                      "17", "16", "15", "10", "5", "1"])
            self.comboBox_5.setCurrentIndex(10)
        if self.comboBox_4.currentText() == "VBR":
            self.label_credits_19.setText("Bitrate:")
            self.label_credits_20.show()
            self.comboBox_6.show()
            self.comboBox_5.addItems(["Smart detect", "65M", "60M", "55M", "50M", "40M", "30M", "20M", "10M", "5M"])
            self.comboBox_6.addItems(["Smart detect", "65M", "60M", "55M", "50M", "40M", "30M", "20M", "10M", "5M"])
            self.comboBox_5.setCurrentIndex(0)
            self.comboBox_6.setCurrentIndex(0)
        if self.comboBox_4.currentText() == "ABR":
            self.label_credits_19.setText("Bitrate:")
            self.label_credits_20.hide()
            self.comboBox_6.hide()
            self.comboBox_5.addItems(["65M", "60M", "55M", "50M", "40M", "30M", "20M", "10M", "5M"])
            self.comboBox_5.setCurrentIndex(3)
        if self.comboBox_4.currentText() == "CRF":
            self.label_credits_19.setText("Quality:")
            self.label_credits_20.hide()
            self.comboBox_6.hide()
            self.comboBox_5.addItems(["51", "45", "40", "35", "30", "25", "24", "23", "22", "21", "20", "19", "18",
                                      "17", "16", "15", "10", "5", "1"])
            self.comboBox_5.setCurrentIndex(10)

    def settings_hdr(self):
        self.lineEdit_7.clear()
        self.lineEdit_8.clear()
        if self.comboBox_15.currentText() == "Unsprt":
            self.lineEdit_7.setText("Unsprt")
            self.lineEdit_8.setText("Unsprt")
        if self.comboBox_15.currentText() == "Undefined":
            self.lineEdit_7.setText(hdr10)
            self.lineEdit_8.setText(hdr11)
        if self.comboBox_15.currentText() == "Display P3":
            self.lineEdit_7.setText("0.680,0.320,0.265,0.690,0.150,0.060")
            self.lineEdit_8.setText("0.3127,0.3290")
        if self.comboBox_15.currentText() == "DCI P3":
            self.lineEdit_7.setText("0.680,0.320,0.265,0.690,0.150,0.060")
            self.lineEdit_8.setText("0.314,0.3510")
        if self.comboBox_15.currentText() == "BT.2020":
            self.lineEdit_7.setText("0.708,0.292,0.170,0.797,0.131,0.046")
            self.lineEdit_8.setText("0.3127,0.3290")
        if self.comboBox_15.currentText() == "BT.709":
            self.lineEdit_7.setText("0.640,0.330,0.30,0.60,0.150,0.060")
            self.lineEdit_8.setText("0.3127,0.3290")

    def settings_menu_audio(self):
        self.comboBox_13.setEnabled(True)
        self.comboBox_13.clear()
        if self.comboBox_12.currentText() == "From source":
            self.comboBox_13.addItems(["From source"])
            self.comboBox_13.setEnabled(False)
        if self.comboBox_12.currentText() == "AAC":
            self.comboBox_13.addItems(["384k", "320k", "256k", "192k", "128k", "96k"])
            self.comboBox_13.setCurrentIndex(2)
        if self.comboBox_12.currentText() == "AC3":
            self.comboBox_13.addItems(["640k", "448k", "384k", "256k"])
            self.comboBox_13.setCurrentIndex(1)
        if self.comboBox_12.currentText() == "DTS":
            self.comboBox_13.addItems(["3840k", "3072k", "2048k", "1920k", "1536k", "1472k", "1344k", "1280k", "1152k",
                                       "1024k", "960k", "768k", "640k", "576k", "512k", "448k", "384k"])
            self.comboBox_13.setCurrentIndex(4)
        if self.comboBox_12.currentText() == "Vorbis":
            self.comboBox_13.addItems(["448k", "384k", "256k", "128k", "96k", "64k"])
            self.comboBox_13.setCurrentIndex(2)
        if self.comboBox_12.currentText() == "Opus":
            self.comboBox_13.addItems(["448k", "384k", "256k", "128k", "96k", "64k"])
            self.comboBox_13.setCurrentIndex(2)
        if self.comboBox_12.currentText() == "PCM 16 bit":
            self.comboBox_13.addItems(["Auto"])
            self.comboBox_13.setEnabled(False)
        if self.comboBox_12.currentText() == "PCM 24 bit":
            self.comboBox_13.addItems(["Auto"])
            self.comboBox_13.setEnabled(False)
        if self.comboBox_12.currentText() == "PCM 32 bit":
            self.comboBox_13.addItems(["Auto"])
            self.comboBox_13.setEnabled(False)

# ------------------------------------------------ Encode File ---------------------------------------------------------
    def smart_detect(self):
        global message
        global input_file, output_file
        global k
        input_file = self.lineEdit_1.text()
        output_file = self.lineEdit_2.text()
        if input_file == "" or output_file == "":
            message = "Select first input and output file!"
            self.task_complete()
            return
        if self.comboBox_5.currentText() == "Smart detect" or self.comboBox_6.currentText() == "Smart detect":
            try:
                media_info = MediaInfo.parse(self.lineEdit_1.text())
                stream_size = str(media_info.tracks[1].stream_size)
                k = round((int(stream_size) * 8) / (int(width) * int(height) * float(fps) * dur), 3)
            except:
                message = "It is impossible to determine the settings for the Smart detect." \
                          " Select the bitrate settings manually."
                self.task_complete()
                return
            else:
                self.smart_settings()
        else:
            self.make_preset()

    def make_preset(self):
        global preset_0, preset, preset_mkvmerge
        global calling_pr_1, calling_pr_2, calling_pr_3, calling_pr_4
        try:
            self.procedure_1.finished.disconnect()
        except:
            pass
        try:
            self.procedure_2.finished.disconnect()
        except:
            pass
        try:
            self.procedure_3.finished.disconnect()
        except:
            pass
        try:
            self.procedure_4.finished.disconnect()
        except:
            pass
        calling_pr_1 = True
        calling_pr_2 = True
        calling_pr_3 = True
        calling_pr_4 = True
        threads = int(multiprocessing.cpu_count())
        vbitrate = str(self.comboBox_5.currentText())
        maxrate = str(self.comboBox_6.currentText())
        quality = str(self.comboBox_5.currentText())
        color_range_curr = str(self.comboBox_16.currentText())
        colorprim_curr = str(self.comboBox_9.currentText()).lower()
        colormatrix_curr = str(self.comboBox_10.currentText()).lower()
        transfer_curr = str(self.comboBox_11.currentText())
        max_lum_curr = str(self.lineEdit_5.text())
        min_lum_curr = str(self.lineEdit_6.text())
        max_cll_curr = str(self.lineEdit_3.text())
        max_fall_curr = str(self.lineEdit_4.text())
        chroma_coord_curr = str(self.lineEdit_7.text())
        white_coord_curr = str(self.lineEdit_8.text())
        color_range = ""
        colorprim = ""
        colormatrix = ""
        transfer = ""
        max_lum = ""
        min_lum = ""
        max_cll = ""
        max_fall = ""
        chroma_coord = ""
        white_coord = ""

# ----------------------------------------------------------------------------------------------------------------------
        if color_range_curr == "Limited":
            color_range = "-color_range tv "

        if color_range_curr == "Full":
            color_range = "-color_range pc "
# ----------------------------------------------------------------------------------------------------------------------
        if colorprim_curr == "bt709":
            colorprim = "-color_primaries bt709 "

        if colorprim_curr == "bt2020":
            colorprim = "-color_primaries bt2020 "
# ----------------------------------------------------------------------------------------------------------------------
        if colormatrix_curr == "bt709":
            colormatrix = "-colorspace bt709 "

        if colormatrix_curr == "bt2020nc":
            colormatrix = "-colorspace bt2020nc "

        if colormatrix_curr == "bt2020c":
            colormatrix = "-colorspace bt2020c "
# ----------------------------------------------------------------------------------------------------------------------
        if transfer_curr == "BT.709":
            transfer = "-color_trc bt709 "

        if transfer_curr == "PQ":
            transfer = "-color_trc smpte2084 "

        if transfer_curr == "HLG":
            transfer = "-color_trc arib-std-b67 "

        if transfer_curr == "BT.2020 (10-bit)":
            transfer = "-color_trc bt2020-10 "
# ----------------------------------------------------------------------------------------------------------------------
        if max_lum_curr != "None":
            max_lum = str(f'-s max-luminance={max_lum_curr} ')
        if max_lum_curr == "" or max_lum_curr == "None":
            max_lum = str(f'-d max-luminance ')

        if min_lum_curr != "None":
            min_lum = str(f'-s min-luminance={min_lum_curr} ')
        if min_lum_curr == "" or min_lum_curr == "None":
            min_lum = str(f'-d min-luminance ')

        if max_cll_curr != "None":
            max_cll = str(f'-s max-content-light={max_cll_curr} ')
        if max_cll_curr == "" or max_cll_curr == "None":
            max_cll = str(f'-d max-content-light ')

        if max_fall_curr != "None":
            max_fall = str(f'-s max-frame-light={max_fall_curr} ')
        if max_fall_curr == "" or max_fall_curr == "None":
            max_fall = str(f'-d max-frame-light ')

        if chroma_coord_curr != "None":
            try:
                chroma_coord_curr_red_x = chroma_coord_curr.split(',')[0]
                chroma_coord_curr_red_y = chroma_coord_curr.split(',')[1]
                chroma_coord_curr_green_x = chroma_coord_curr.split(',')[2]
                chroma_coord_curr_green_y = chroma_coord_curr.split(',')[3]
                chroma_coord_curr_blue_x = chroma_coord_curr.split(',')[4]
                chroma_coord_curr_blue_y = chroma_coord_curr.split(',')[5]
                chroma_coord = str(f'-s chromaticity-coordinates-red-x={chroma_coord_curr_red_x} -s chromaticity'
                                   f'-coordinates-red-y={chroma_coord_curr_red_y} -s chromaticity-c'
                                   f'oordinates-green-x={chroma_coord_curr_green_x} '
                                   f'-s chromaticity-coordinates-green-y='
                                   f'{chroma_coord_curr_green_y} -s chromaticity-coordinates-blue-x='
                                   f'{chroma_coord_curr_blue_x} -s chromaticity-coordinates-blue-y='
                                   f'{chroma_coord_curr_blue_y} ')
            except:
                pass
        if chroma_coord_curr == "" or chroma_coord_curr == "None":
            chroma_coord = str(f'-d chromaticity-coordinates-red-x -d chromaticity-coordinates-red-y -d '
                               f'chromaticity-coordinates-green-x -d chromaticity-coordinates-green-y -d '
                               f'chromaticity-coordinates-blue-x -d chromaticity-coordinates-blue-y ')

        if white_coord_curr != "None":
            try:
                white_coord_curr_x = white_coord_curr.split(',')[0]
                white_coord_curr_y = white_coord_curr.split(',')[1]
                white_coord = str(f'-s white-coordinates-x={white_coord_curr_x} '
                                  f'-s white-coordinates-y={white_coord_curr_y} ')
            except:
                pass
        if white_coord_curr == "" or white_coord_curr == "None":
            white_coord = str(f'-d white-coordinates-x -d white-coordinates-y ')

# ----------------------------------------------------------------------------------------------------------------------
        abitrate = str(self.comboBox_13.currentText())
        if self.comboBox_12.currentText() == "From source":
            apreset = "-c:a copy"
        if self.comboBox_12.currentText() == "AAC":
            apreset = f'-c:a aac -b:a {abitrate}'
        if self.comboBox_12.currentText() == "AC3":
            apreset = f'-c:a ac3 -b:a {abitrate}'
        if self.comboBox_12.currentText() == "DTS":
            apreset = f'-strict -2 -c:a dca -b:a {abitrate} -ar 48000'
        if self.comboBox_12.currentText() == "Vorbis":
            apreset = f'-c:a libvorbis -b:a {abitrate}'
        if self.comboBox_12.currentText() == "Opus":
            apreset = f'-c:a libopus -b:a {abitrate}'
        if self.comboBox_12.currentText() == "PCM 16 bit":
            apreset = "-c:a pcm_s16le"
        if self.comboBox_12.currentText() == "PCM 24 bit":
            apreset = "-c:a pcm_s24le"
        if self.comboBox_12.currentText() == "PCM 32 bit":
            apreset = "-c:a pcm_s32le"

        preset_mkvmerge = str(f'{max_cll}{max_fall}{max_lum}{min_lum}{chroma_coord}{white_coord} ')
        #{color_range_mkv}{colorprim_mkv}{colormatrix_mkv}{transfer_mkv}


        if self.comboBox_1.currentText() == "H265  10 bit" and self.comboBox_3.currentText() == "NVENC":
            if self.comboBox_4.currentText() == "CQP":
                preset = str(f'-map_metadata -1 -map 0:v:0 -b:v 0 -pix_fmt p010le -c:v hevc_nvenc -preset slow -rc vbr_hq -cq {quality} '
                             f'-qmin {quality} -qmax {quality} -rc-lookahead 32 -profile:v main10 {color_range}'
                             f'{colorprim}{colormatrix}{transfer}-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "VBR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt p010le -b:v {vbitrate} -maxrate:v {maxrate} -bufsize {maxrate} -c:v hevc_nvenc -preset slow '
                             f'-rc vbr_hq -2pass 1 -rc-lookahead 32 -profile:v main10 {color_range}'
                             f'{colorprim}{colormatrix}{transfer}-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            preset_0 = str(f'-hide_banner -threads:v {threads/2} -threads:a {threads} -hwaccel cuda ')
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "H265  10 bit" and self.comboBox_3.currentText() == "CPU":
            if self.comboBox_4.currentText() == "CQP":
                preset = str(f'-map_metadata -1 -map 0:v:0 -b:v 0 -pix_fmt yuv420p10le -c:v libx265 -preset slow -rc vbr_hq -cq {quality} '
                             f'-qmin {quality} -qmax {quality} -rc-lookahead 32 -profile:v main10 {color_range}'
                             f'{colorprim}{colormatrix}{transfer}-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "VBR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p10le -b:v {vbitrate} -maxrate:v {maxrate} -bufsize {maxrate} -c:v libx265 -preset slow '
                             f'-rc vbr_hq -rc-lookahead 32 -profile:v main10 {color_range}'
                             f'{colorprim}{colormatrix}{transfer}-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner "
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "VP9  10 bit":
            if self.comboBox_4.currentText() == "CRF":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p10le -c:v libvpx-vp9 -speed 4 -profile:v 2 -crf {quality} -b:v 0 '
                             f'{color_range}{colorprim}{colormatrix}{transfer}-map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "ABR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p10le -c:v libvpx-vp9 -speed 4 -profile:v 2 -b:v {vbitrate} '
                             f'{color_range}{colorprim}{colormatrix}{transfer}-map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner "
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "AV1  10 bit":
            if self.comboBox_4.currentText() == "CRF":
                preset = str(f'-map_metadata -1 -map 0:v:0 -c:v librav1e -crf {quality} -b:v 0 -strict -2 '
                             f'{color_range}{colorprim}{colormatrix}{transfer}-map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "ABR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -c:v librav1e -b:v {vbitrate} -strict -2 '
                             f'{color_range}{colorprim}{colormatrix}{transfer}-map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner "
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "H265  8 bit" and self.comboBox_3.currentText() == "NVENC":
            if self.comboBox_4.currentText() == "CQP":
                preset = str(f'-map_metadata -1 -map 0:v:0 -b:v 0 -pix_fmt yuv420p -c:v hevc_nvenc -preset slow -rc vbr_hq -cq {quality} '
                             f'-qmin {quality} -qmax {quality} -rc-lookahead 32 -profile:v main '
                             f'-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "VBR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p -b:v {vbitrate} -maxrate:v {maxrate} -bufsize {maxrate} -c:v hevc_nvenc -preset slow '
                             f'-rc vbr_hq -2pass 1 -rc-lookahead 32 -profile:v main -max_muxing_queue_size 1024 '
                             f'-map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner -hwaccel cuda "
            self.encode_file()

        if self.comboBox_1.currentText() == "H265  8 bit" and self.comboBox_3.currentText() == "CPU":
            if self.comboBox_4.currentText() == "CQP":
                preset = str(f'-map_metadata -1 -map 0:v:0 -b:v 0 -pix_fmt yuv420p -c:v libx265 -preset slow -rc vbr_hq -cq {quality} '
                             f'-qmin {quality} -qmax {quality} -rc-lookahead 32 -profile:v main '
                             f'-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "VBR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p -b:v {vbitrate} -maxrate:v {maxrate} -bufsize {maxrate} -c:v libx265 -preset slow '
                             f'-rc vbr_hq -rc-lookahead 32 -profile:v main -max_muxing_queue_size 1024 '
                             f'-map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner "
            self.encode_file()

        if self.comboBox_1.currentText() == "H264  8 bit" and self.comboBox_3.currentText() == "NVENC":
            if self.comboBox_4.currentText() == "CQP":
                preset = str(f'-map_metadata -1 -map 0:v:0 -b:v 0 -pix_fmt yuv420p -c:v h264_nvenc -preset slow -rc vbr_hq -cq {quality} '
                             f'-qmin {quality} -qmax {quality} -rc-lookahead 32 -profile:v high '
                             f'-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "VBR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p -b:v {vbitrate} -maxrate:v {maxrate} -bufsize {maxrate} -c:v h264_nvenc -preset slow '
                             f'-rc vbr_hq -2pass 1 -rc-lookahead 32 -profile:v high -max_muxing_queue_size 1024 '
                             f'-map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner -hwaccel cuda "
            self.encode_file()

        if self.comboBox_1.currentText() == "H264  8 bit" and self.comboBox_3.currentText() == "CPU":
            if self.comboBox_4.currentText() == "CQP":
                preset = str(f'-map_metadata -1 -map 0:v:0 -b:v 0 -pix_fmt yuv420p -c:v libx264 -preset slow -rc vbr_hq -cq {quality} '
                             f'-qmin {quality} -qmax {quality} -rc-lookahead 32 -profile:v high '
                             f'-max_muxing_queue_size 1024 -map 0:a {apreset} -f matroska ')
            if self.comboBox_4.currentText() == "VBR":
                preset = str(f'-map_metadata -1 -map 0:v:0 -pix_fmt yuv420p -b:v {vbitrate} -maxrate:v {maxrate} -bufsize {maxrate} -c:v libx264 -preset slow '
                             f'-rc vbr_hq -2pass 1 -rc-lookahead 32 -profile:v high -max_muxing_queue_size 1024 '
                             f'-map 0:a {apreset} -f matroska ')
            preset_0 = "-hide_banner "
            self.encode_file()

        if self.comboBox_1.currentText() == "ProRes HQ":
            preset = str(f'-map 0:v:0 -pix_fmt yuv422p10le -c:v prores_ks -profile:v 3'
                         f' {color_range}{colorprim}{colormatrix}{transfer}-map 0:a:0 {apreset}')
            preset_0 = "-hide_banner "
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "ProRes 4444":
            preset = str(f'-map 0:v:0 -pix_fmt yuv444p10 -c:v prores_ks -profile:v 4'
                         f' {color_range}{colorprim}{colormatrix}{transfer}-map 0:a:0 {apreset}')
            preset_0 = "-hide_banner "
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "DNxHR HQX":
            preset = str(f'-map 0:v:0 -pix_fmt yuv422p10le -c:v dnxhd -profile:v dnxhr_hqx -bits_per_raw_sample 10 '
                         f'{color_range}{colorprim}{colormatrix}{transfer}-map 0:a:0 {apreset}')
            preset_0 = "-hide_banner "
            self.encode_mux_file()

        if self.comboBox_1.currentText() == "From source":
            preset = str(f'-map 0:v:0 -movflags +write_colr -c:v copy -map 0:a {apreset} ')
            preset_0 = "-hide_banner "
            self.encode_mux_file()


    def encode_mux_file(self):
        global fr_count, message, loop_start
        #global input_file, output_file
        global temp_folder, temp_file
        self.procedure_1.finished.connect(self.error)
        #input_file = self.lineEdit_1.text()
        #output_file = self.lineEdit_2.text()
        #if input_file == "" or output_file == "":
        #    message = "Select first input and output file!"
        #    self.task_complete()
        #    return
        try:
            f = open(r'./.ce_settings', 'r', encoding='utf-8')
        except:
            message = "Please set up a temporary folder!\n"
            self.task_complete()
            return
        else:
            i = 0
            a = []
            for line in f:
                i = i + 1
                a.append(line)
                if i == 1:
                    if a[0].find('temp_folder:') != -1 and a[0].find('[default]') != -1:
                        temp_folder = output_file + "_temp"
                        temp_file = temp_folder + "/temp.mkv"
                    if a[0].find('temp_folder:') != -1 and a[0].find('[default]') == -1:
                        b = a[0].split(':')
                        c = b[1].replace('[', '').replace(']\n', '')
                        temp_folder = c + "/_temp"
                        temp_file = temp_folder + "/temp.mkv"
            f.close()
            if i == 0:
                message = "Settings file error!\n"
                self.task_complete()
                return
            self.pushButton_1.setEnabled(False)
            self.pushButton_2.setEnabled(False)
            self.pushButton_3.setEnabled(False)
            try:
                os.mkdir(temp_folder)
            except:
                self.pushButton_1.setEnabled(True)
                self.pushButton_2.setEnabled(True)
                self.pushButton_3.setEnabled(True)
                message = "Please clear temporary folder or select other temporary folder."
                self.task_complete()
            else:
                try:
                    media_info = MediaInfo.parse(input_file)
                    dur = 0.001*float(media_info.tracks[0].duration)
                    fps = float(media_info.tracks[0].frame_rate)
                    dur_mod = round(dur)
                    fps_mod = round(fps, 2)
                    fr_count = round(dur_mod*fps_mod)
                except:
                    self.pushButton_1.setEnabled(True)
                    self.pushButton_2.setEnabled(True)
                    self.pushButton_3.setEnabled(True)
                    message = "Select the correct input and output file!"
                    self.task_complete()
                else:
                    self.label_53.show()
                    self.label_53.setText("Encoding:")
                    self.label_54.show()
                    self.label_55.show()
                    self.progressBar.show()
                    self.progressBar.setProperty("value", 0)
                    loop_start = time.perf_counter()
                    try:
                        cmd = f'ffmpeg {preset_0}-i "{input_file}" {preset} -y "{temp_file}" '
                        self.procedure_1.start(cmd)
                    except:
                        self.pushButton_1.setEnabled(True)
                        self.pushButton_2.setEnabled(True)
                        self.pushButton_3.setEnabled(True)
                        message = "An unknown error occured!\n"
                        self.task_complete()

    def add_metadata(self):
        global message
        self.procedure_1.finished.disconnect(self.add_metadata)
        self.procedure_2.finished.connect(self.error)
        self.label_53.setText("Add data:")
        self.progressBar.setProperty("value", 0)
        try:
            cmd = f'mkvpropedit --edit track:1 {preset_mkvmerge} "{temp_file}" '
            self.procedure_2.start(cmd)
        except:
            self.pushButton_1.setEnabled(True)
            self.pushButton_2.setEnabled(True)
            self.pushButton_3.setEnabled(True)
            message = "An unknown error occured!\n"
            self.task_complete()

    def mux(self):
        global message
        self.procedure_2.finished.disconnect(self.mux)
        self.procedure_3.finished.connect(self.error)
        self.label_53.setText("Muxing:")
        self.progressBar.setProperty("value", 0)
        try:
            cmd = f'ffmpeg -hide_banner -i "{temp_file}" -map 0:0 -movflags +write_colr -c:v copy -map 0:a -c:a copy -y "{output_file}" '
            self.procedure_3.start(cmd)
        except:
            self.pushButton_1.setEnabled(True)
            self.pushButton_2.setEnabled(True)
            self.pushButton_3.setEnabled(True)
            message = "An unknown error occured!\n"
            self.task_complete()

    def complete_mux(self):
        global message
        self.procedure_3.finished.disconnect(self.complete_mux)
        time.sleep(0.1)
        self.pushButton_1.setEnabled(True)
        self.pushButton_2.setEnabled(True)
        self.pushButton_3.setEnabled(True)
        try:
            os.remove(temp_file)
            time.sleep(0.2)
            os.rmdir(temp_folder)
        except:
            message = "Task completed!\nPlease, clear temporary folder manually.\n"
            self.task_complete()
        else:
            message = "Task completed!\n"
            self.task_complete()


    def encode_file(self):
        global fr_count, message, loop_start
        self.procedure_4.finished.connect(self.error)
        #input_file = self.lineEdit_1.text()
        #output_file = self.lineEdit_2.text()
        #if input_file == "" or output_file == "":
        #    message = "Select first input and output file!"
        #    self.task_complete()
        #    return
        self.pushButton_1.setEnabled(False)
        self.pushButton_2.setEnabled(False)
        self.pushButton_3.setEnabled(False)
        try:
            media_info = MediaInfo.parse(input_file)
            dur = 0.001*float(media_info.tracks[0].duration)
            fps = float(media_info.tracks[0].frame_rate)
            dur_mod = round(dur)
            fps_mod = round(fps, 2)
            fr_count = round(dur_mod*fps_mod)
        except:
            self.pushButton_1.setEnabled(True)
            self.pushButton_2.setEnabled(True)
            self.pushButton_3.setEnabled(True)
            message = "Select the correct input and output file!"
            self.task_complete()
        else:
            self.label_53.show()
            self.label_53.setText("Encoding:")
            self.label_54.show()
            self.label_55.show()
            self.progressBar.show()
            self.progressBar.setProperty("value", 0)
            loop_start = time.perf_counter()
            try:
                cmd = f'ffmpeg {preset_0}-i "{input_file}" {preset} -y "{output_file}" '
                self.procedure_4.start(cmd)
            except:
                self.pushButton_1.setEnabled(True)
                self.pushButton_2.setEnabled(True)
                self.pushButton_3.setEnabled(True)
                message = "An unknown error occured!\n"
                self.task_complete()

    def complete(self):
        global message
        self.procedure_4.finished.disconnect(self.complete)
        self.pushButton_1.setEnabled(True)
        self.pushButton_2.setEnabled(True)
        self.pushButton_3.setEnabled(True)
        message = "Task completed!\n"
        self.task_complete()


    def progress_1(self):
        global calling_pr_1
        line = str(self.procedure_1.readAllStandardOutput())
        line_mod6 = line.replace('   ', ' ').replace('  ', ' ').replace('  ', ' ').replace('= ', '=')
        pos_st = line_mod6.find('frame=')
        if pos_st == 2:
            data = line_mod6.split(' ')
            frame = int(data[0].replace("b'frame=", ""))
            iter_start = time.perf_counter()
            timer = iter_start - loop_start
            full_time = (timer*fr_count)/(frame)
            rem_time = full_time - timer
            h = math.trunc(rem_time / 3600)
            m = math.trunc((rem_time - (h * 3600)) / 60)
            s = math.trunc(rem_time - (h * 3600) - (m * 60))
            percent = 0.9 + (frame*100)/fr_count
            if percent > 100:
                percent = 100
            self.progressBar.setProperty("value", percent)
            self.label_55.setText(str(h).rjust(2, '0') + ":" + str(m).rjust(2, '0') + ":" + str(s).rjust(2, '0'))
            if (percent >= 50) and (calling_pr_1 == True):
                self.procedure_1.finished.disconnect(self.error)
                self.procedure_1.finished.connect(self.add_metadata)
                calling_pr_1 = False

    def progress_2(self):
        global calling_pr_2
        line = str(self.procedure_2.readAllStandardOutput())
        pos_st = line.find('Done.')
        pos_nf = line.find('Nothing to do.')
        if pos_st != -1 or pos_nf != -1:
            percent = 100
            self.progressBar.setProperty("value", percent)
            if (percent == 100) and (calling_pr_2 == True):
                self.procedure_2.finished.disconnect(self.error)
                self.procedure_2.finished.connect(self.mux)
                global loop_start
                loop_start = round(time.perf_counter())
                calling_pr_2 = False

    def progress_3(self):
        global calling_pr_3
        line = str(self.procedure_3.readAllStandardOutput())
        line_mod6 = line.replace('   ', ' ').replace('  ', ' ').replace('  ', ' ').replace('= ', '=')
        pos_st = line_mod6.find('frame=')
        if pos_st == 2:
            data = line_mod6.split(' ')
            frame = int(data[0].replace("b'frame=", ""))
            iter_start = time.perf_counter()
            timer = iter_start - loop_start
            full_time = (timer * fr_count) / (frame)
            rem_time = full_time - timer
            h = math.trunc(rem_time / 3600)
            m = math.trunc((rem_time - (h * 3600)) / 60)
            s = math.trunc(rem_time - (h * 3600) - (m * 60))
            percent = 0.9 + (frame*100)/fr_count
            if percent > 100:
                percent = 100
            self.progressBar.setProperty("value", percent)
            self.label_55.setText(str(h).rjust(2, '0') + ":" + str(m).rjust(2, '0') + ":" + str(s).rjust(2, '0'))
            if (percent >= 50) and (calling_pr_3 == True):
                self.procedure_3.finished.disconnect(self.error)
                self.procedure_3.finished.connect(self.complete_mux)
                calling_pr_3 = False

    def progress_4(self):
        global calling_pr_4
        line = str(self.procedure_4.readAllStandardOutput())
        line_mod6 = line.replace('   ', ' ').replace('  ', ' ').replace('  ', ' ').replace('= ', '=')
        pos_st = line_mod6.find('frame=')
        if pos_st == 2:
            data = line_mod6.split(' ')
            frame = int(data[0].replace("b'frame=", ""))
            iter_start = time.perf_counter()
            timer = iter_start - loop_start
            full_time = (timer * fr_count) / (frame)
            rem_time = full_time - timer
            h = math.trunc(rem_time / 3600)
            m = math.trunc((rem_time - (h * 3600)) / 60)
            s = math.trunc(rem_time - (h * 3600) - (m * 60))
            percent = 0.9 + (frame*100)/fr_count
            if percent > 100:
                percent = 100
            self.progressBar.setProperty("value", percent)
            self.label_55.setText(str(h).rjust(2, '0') + ":" + str(m).rjust(2, '0') + ":" + str(s).rjust(2, '0'))
            if (percent >= 50) and (calling_pr_4 == True):
                self.procedure_4.finished.disconnect(self.error)
                self.procedure_4.finished.connect(self.complete)
                calling_pr_4 = False


    def error(self):
        global message
        try:
            self.procedure_1.finished.disconnect(self.error)
        except:
            pass
        try:
            self.procedure_2.finished.disconnect(self.error)
        except:
            pass
        try:
            self.procedure_3.finished.disconnect(self.error)
        except:
            pass
        try:
            self.procedure_4.finished.disconnect(self.error)
        except:
            pass
        self.pushButton_1.setEnabled(True)
        self.pushButton_2.setEnabled(True)
        self.pushButton_3.setEnabled(True)
        message = "An error occured!\nPossible reasons:\n - incorrect encoder settings or error in " \
                  "the input file,\n - no enough space on the disk."
        self.task_complete()

    def cancel(self):
        global message
        self.pushButton_1.setEnabled(True)
        self.pushButton_2.setEnabled(True)
        self.pushButton_3.setEnabled(True)
        message = "All processes are cancelled!\n"
        self.task_complete()

    def stop(self):
        try:
            self.procedure_1.finished.disconnect()
        except:
            pass
        try:
            self.procedure_2.finished.disconnect()
        except:
            pass
        try:
            self.procedure_3.finished.disconnect()
        except:
            pass
        try:
            self.procedure_4.finished.disconnect()
        except:
            pass
        self.procedure_1.finished.connect(self.cancel)
        self.procedure_2.finished.connect(self.cancel)
        self.procedure_3.finished.connect(self.cancel)
        self.procedure_4.finished.connect(self.cancel)
        try:
            self.procedure_1.kill()
        except:
            pass
        try:
            self.procedure_2.kill()
        except:
            pass
        try:
            self.procedure_3.kill()
        except:
            pass
        try:
            self.procedure_4.kill()
        except:
            pass

# --------------------------------------------------------------------------------------------------------------------

class TaskCompleteApp(QtWidgets.QMainWindow, ui_taskcomplete.Ui_TaskComplete):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

class DonateApp(QtWidgets.QMainWindow, ui_donate.Ui_Donate):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

class AboutApp(QtWidgets.QMainWindow, ui_about.Ui_About):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

class SettingsApp(QtWidgets.QMainWindow, ui_settings.Ui_Settings):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

class SmartSettingsApp(QtWidgets.QMainWindow, ui_smartsettings.Ui_SmartSettings):
    def __init__(self):
        super().__init__()
        self.setupUi(self)


def main():
    app = QtWidgets.QApplication(sys.argv)
    window = ExampleApp()
    window.show()
    app.exec_()

if __name__ == '__main__':  # if run direct
    main()  # run main()
